' htmlLEDs.bas
' html framework by matherp: https://www.thebackshed.com/forum/ViewTopic.php?TID=9115&PID=99605
'  option autorun on
  Option explicit
  option default FLOAT ' none
  option base 1
 
  SetPin 1,uart0tx:SetPin 2,uart0rx ' : Open "com0:115200" As #1

  const sim=1 ' on pico, get around non-working commands
  
  ' Global variables
  const quote=chr$(34)
  CONST SSID$=quote+"Omnibus_N"+quote
  CONST SSIDPassword$=quote+"amber1977"+quote
'  const portno$="1234" 'set the port to be used for the webserver
  const portno$="9059" 'set the port to be used for the webserver
  '
  const starttext$="HTTP"
  const pnf$="<html><body>Page not Found</body></html>"
  const title$="<html><head><title>Some Title</title></head><body>"
  const ending$="</form></body></html>"
  const ON=1
  const off=0
  const TRUE=1
  const FALSE=0
  
  const hVarMax=30
  const maxLen=2000
  const nColors=7
  '   
  dim integer i,j,k,l,m, iPos, jPos
  dim as string a$,b$,c$,d$,e$,s$
  '
  ' Set up parameters
  '
  const waittime=1000 'wait time in readrequest before timeout
  '
  '
  Dim arg$(2,hVarmax) length 20
  DIM INTEGER inbuf(Maxlen\4) 'global input buffer
  dim string CRLF=chr$(13)+chr$(10)
  
  dim integer IPDno  'global IPD numbers used to ensure transmit is on correct IPD
  dim integer nparams, connected=0
  dim as string pageX$ 'variables used by main loop only
  dim as string lastPageType$ length 1 ' I=INDEX,S=SIM,
  dim as integer firstSend=1
  DIM obuff$="" 'used to buffer writes to the internet to optimise speed
  DIM AS string sVarVals(26) length 30
  Dim as string sColors(nColors)=("gray","red","green","blue","yellow","orange","purple")
  dim as integer p(26),pPin(26),pColor(26),pChecked(26),rvrsP(40)

  CONST longStringMaxLen=2000
  DIM as string htmlRequest$
  dim as INTEGER htmlBuffer(longStringMaxLen/4) ' LB 170310
  DIM AS STRING htmlLine, templateLine, sHTMLVarNo length 2
  CONST maxVars=26
  DIM AS INTEGER nVarNdx(maxVars), nVarNos(maxVars), flagVarChanged

  dim string hdr1="<!DOCTYPE html> <html><head></head>"+CRLF
  dim string hdr2="<body bgcolor=#d0d0d0><form name='f1' method='get' action='L'><p>"
  dim string hdr3="<left>&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;PicoMite LEDs<br>"+CRLF
  dim string tbl1="<table border = 5 bordercolor = red align = left><tr><td><table>"+CRLF
  dim string tbl1row="<tr><td bgcolor=~ style=font-size:17px>&emsp;</td></tr>"+CRLF
  dim string tbl2="    </table></td><td><table>"+CRLF
  dim string tbl2row="<tr><td><input type=checkbox ~></td></tr>"+CRLF
  dim string tbl3="    </table></td><td><table><p style=font-size:17px>"+CRLF
  a$="<tr><td style=font-size:4px>"
  b$="___________________________________________"
  dim string tbl3rowFirst=a$+"&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;"+b$+"</td></tr"+CRLF
  dim string tbl3row="<tr><td style=font-size:17px>~ |&emsp;&emsp;&emsp;&emsp;&emsp;| ~</td></tr>"+CRLF
  dim string tbl3row20="<tr><td style=font-size:17px>20 |__________| 21</td></tr>"+CRLF
  dim string tbl3rowLast="<tr><td style=font-size:12px>&emsp;&emsp;</td></tr>"+CRLF
  dim string tbl4="</p></table></td><td><table>"+CRLF
  dim string tbl4row="<tr><td><input type=checkbox ~></td></tr>"+CRLF
  dim string tbl5="    </table></td><td><table>"+CRLF
  dim string tbl5row="<tr><td bgcolor=~ style=font-size:17px>&emsp;</td></tr>"+CRLF
  dim string tail=" </table></td>"+CRLF+"</tr>"+CRLF
  dim string tail2="<tr><td></td><td></td><td><center><input type='submit' value='Submit'></center>"
  dim string tail3="</td><td></td><td></td></tr></table></form></body>"+CRLF+"<html>"
  ''
  Init:
  pause 5000 'wait for ESP8266 to stabilise after power on
  print "Opening COM for ESP-01"
  open "com0:115200,4096" as #9
'  pin(resetpin)=1 'release the ESP8266 from reset
  timer=0
  do while TIMER<20000
    IF loc(#9)<>0 then 
      longstring append inbuf(),input$(min(255,loc(#9)),#9)
    endif
    if LLen(inbuf())>15 then
      if LInstr(inbuf(),"WIFI GOT IP") then
        connected=1 'set that we have got a connection
        exit DO
      endif
    endif
  loop
  close #9 'clear the buffer
  print "Reopening COM for ESP-01 as #9 for html simulation "
  SetPin 1,uart0tx:SetPin 2,uart0rx ' : Open "com0:115200" As #1
  open "com0:115200,4096" as #9
  print #9,"+++"; 'ensure the ESP is in command mode
  pause 500
  IF NOT Command("AT",500) THEN END  'If not responding to AT we have a problem
  if not connected then
    IF NOT Command("AT+RST",10000,"WIFI GOT IP") THEN 'software reset and check for valid connection
      PRINT "Set up WIFI on SSID: ",SSID$
      IF NOT Command("AT+CWMODE_DEF=1",5000) THEN END 'set device mode (1=client, 2=AP, 3=both)
      IF NOT Command("AT+CWLAP",30000) THEN END 'scan for WiFi hotspots
      LONGSTRING print inbuf() 'output the list of valid networks
      IF NOT Command("AT+CWJAP_DEF="+SSID$+","+SSIDPassword$,20000,"WIFI GOT IP") THEN END 'connect
      IF NOT Command("AT+CIFSR",5000) THEN END 'check IP address
    ENDIF
  else
  endif
  IF NOT Command("AT+CIPMUX=1",5000) THEN END
  IF NOT Command("AT+CIPSERVER=1,"+portno$,5000) THEN END
  IF NOT Command("AT+CIPSTA="+quote+"192.168.2.124"+quote,5000) then : endif
  pause 1000
  print "Getting IP: ";
  IF Command("AT+CIFSR",5000) THEN  'check IP address
'    pause 1000
    iPos=LInstr(inbuf(),quote,1) ' opening quote
    if iPos > 0 then
      jPos=LInstr(inbuf(),quote,iPos+1) ' closing quote
      if jPos > 0 then
        print LGetStr$(inbuf(),iPos+1,jPos-iPos-1)
      endif
    endif
    print LGetStr$(inbuf(),1,140)
  endif
  for i=1 to 26: p(i)=i: next i: p(24)=26: p(25)=27: p(26)=28 ' set up pin #s
  for i=3 to 26: pColor(i)=fix(rnd*(nColors-1)+2): next i ' to test, set up random colors
  ' set up pin number to LED index
  rvrsP(4)=3:rvrsP(5)=4:rvrsP(6)=5:rvrsP(7)=6:rvrsP(9)=7:rvrsP(10)=8:rvrsP(11)=9:rvrsP(12)=10
  rvrsP(14)=11:rvrsP(15)=12:rvrsP(16)=13:rvrsP(17)=14:rvrsP(19)=15:rvrsP(20)=16
  rvrsP(21)=17:rvrsP(22)=18:rvrsP(24)=19:rvrsP(25)=20:rvrsP(26)=21:rvrsP(27)=22:
  rvrsP(29)=23:rvrsP(31)=24:rvrsP(32)=25:rvrsP(34)=26
  pPin(1)=1:pPin(2)=2:pPin(3)=4:pPin(4)=5:pPin(5)=6:pPin(6)=7:pPin(7)=9:pPin(8)=10:
  pPin(9)=11:pPin(10)=12:pPin(11)=14:pPin(12)=15:pPin(13)=16:pPin(14)=17
  pPin(15)=19:pPin(16)=20:
  pPin(17)=21:pPin(18)=22:pPin(19)=24:pPin(20)=25:pPin(21)=26:pPin(22)=27
  pPin(23)=29:pPin(24)=31:pPin(25)=32:pPin(26)=34
  for i=3 to 26: pChecked(i)=fix(rnd+.5): next i ' ??? testing: randomly checked
  for i=3 to 26: setpin pPin(i),dout: pin(pPin(i))=pChecked(i): next i
  Print ""
  Print "Connected"
  print "Ready for user input"
  
main:
  DO
    if ReadRequest(waittime) then 
        'process HTML request (watchdog: requestpin)
      htmlRequest$ = parsehtmldata$(nparams) ' builds arg$(1/2,nparams) name/value pairs
      print "nparams: ";nparams;": |";htmlRequest$;"|"
      pageX$=ucase$(htmlRequest$) 
      if pageX$<>"" then 'real request so do something
        firstSend = 1 ' LB print first buffer of html code sent
        if pageX$= "INDEX" then
          drawpage
          firstSend = 1 ' LB print first buffer of html code sent
        elseif pageX$= "L" then ' LED form
          if nparams<>0 then 'we have parameters to process
            print "nparams: "+str$(nparams)
            flagVarChanged = FALSE
            for i=3 to 26: pChecked(i)=0: next i ' reset all
            for i = 1 to nparams
              if arg$(1,i) <> "" then
                k=asc(arg$(1,i))-asc("A")+1
                print arg$(1,i)+"="+arg$(2,i)+"-";k;" ";
                if k >2 and k < 27 then pChecked(k)=1
              endif
            next i
            print ""
          endif
          for i=3 to 26: pin(pPin(i))=pChecked(i): next i ' LED on or off
          drawpage
        elseif pageX$="A" then
          sendText "HTTP/1.1 200 OK"+crlf+"Content-type: text/html"+crlf+"Connection: close"+crlf+crlf
          firstSend = 1
          sendText title$+"Bingo!</body></html>"+crlf+crlf
        else
          sendText "HTTP/1.1 200 OK"+crlf+"Content-type: text/html"+crlf+"Connection: close"+crlf+crlf
          SendText pnf$+crlf+crlf'invalid page
        endif
        EndSend 'clear the write buffer and terminate the write
      endif
    endif
  LOOP
end
  
sub drawpage
?"Entering drawpage"
  sendText "HTTP/1.1 200 OK"+crlf+"Content-type: text/html"+crlf+"Connection: close"+crlf+crlf
'  putHTML

  sendText hdr1+hdr2+hdr3+tbl1
  j=instr(tbl1row,"~")
  ' <tr><td bgcolor=~ style=font-size:17px>&emsp;</td></tr>
  if j>0 then
    a$=mid$(tbl1row,1,j-1): c$=mid$(tbl1row,j+1)
    for i=1 to 20
      if rvrsP(i)=0 then: b$="gray"
      else
        if pChecked(rvrsP(i)) then b$=sColors(pColor(rvrsP(i))) else b$="white"
      endif
      sendText a$+b$+c$
    next i
  endif

  sendText tbl2
  j=instr(tbl2row,"~")
  ' <tr><td><input type=checkbox ~></td></tr>
  if j>0 then
    a$=mid$(tbl2row,1,j-1): c$=mid$(tbl2row,j+1)
    for i=1 to 20
      if rvrsP(i)=0 then
        b$="disabled"
      else
        s$=" name="+chr$(asc("A")+rvrsP(i)-1)
        if pChecked(rvrsP(i)) then b$="checked"+s else b$=s$ 
      endif
      sendText a$+b$+c$
    next i
  endif
  
  sendText tbl3
  sendText tbl3rowFirst
  j=instr(tbl3row,"~")
  ' <tr><td><input type=checkbox ~></td></tr>
  if j>0 then
    k=instr(j+1,tbl3row,"~")
    a$=mid$(tbl3row,1,j-1): c$=mid$(tbl3row,j+1,k-j-1): e$=mid$(tbl3row,k+1)
    for i=1 to 19
      if i<10 then
        b$="&ensp;"+str$(i)
      else
        b=str$(i)
      endif
      d=str$(41-i)
      sendText a$+b$+c$+d$+e$
    next i
  endif
  sendText tbl3row20
  sendText tbl3rowLast
  
  sendText tbl4
  j=instr(tbl4row,"~")
  ' <tr><td><input type=checkbox ~></td></tr>
  if j>0 then
    a$=mid$(tbl4row,1,j-1): c$=mid$(tbl4row,j+1)
    for i=40 to 21 step -1
      if rvrsP(i)=0 then
        b$="disabled"
      else
        s$=" name="+chr$(asc("A")+rvrsP(i)-1)
        if pChecked(rvrsP(i)) then b$="checked"+s else b$=s$ 
      endif
      sendText a$+b$+c$
    next i
  endif
  
  sendText tbl5
  j=instr(tbl1row,"~")
  ' <tr><td bgcolor=~ style=font-size:17px>&emsp;</td></tr>
  if j>0 then
    a$=mid$(tbl5row,1,j-1): c$=mid$(tbl5row,j+1)
'    for i=21 to 40
    for i=40 to 21 step -1
      if rvrsP(i)=0 then: b$="gray"
      else
        if pChecked(rvrsP(i)) then b$=sColors(pColor(rvrsP(i))) else b$="white"
      endif
      sendText a$+b$+c$
    next i
  endif

  sendText tail+tail2
  sendText tail3+crlf+crlf
  print "html page output complete "+mid$(TIMe$,1,5)
end sub
'
Function parsehtmldata$(paramcount as integer)
  local a$,b$
  local INTEGER buf(Maxlen\4)
  local integer inpos,startparam,processargs
  paramcount=1 ' LB as array index, values starting from 1 instead of from 0
  inpos=LInstr(inbuf(),"GET /",1)
  if inpos=0 then
    parsehtmldata$=""
  else
'    LONGSTRING MID buf(),inbuf(),inpos+5
    LONGSTRING MID buf(),inbuf(),inpos+5, 255
    inpos=LInstr(buf(),starttext$,1)
    if inpos > 0 then 
'      logToFile("!",LGetStr$(buf(), 1, inpos-1)) ' log input request
    endif
    print LGetStr$(buf(), 1, 100)
    If inpos>2 Then 'page request found
      inpos=inpos-2
      a$=LGetStr$(buf(),1,inPos)
      inpos=Instr(a$,"?")
      If inpos<>0 Then 'parameters found
        processargs=1
        parsehtmldata$=Left$(a$,inpos-1)
        a$=Mid$(a$,inpos+1)
        Do
          arg$(1,paramcount)=""
          arg$(2,paramcount)=""
          inpos=Instr(a$,"=")
          startparam=1
          arg$(1,paramcount)=Mid$(a$,startparam,inpos-startparam)
          startparam=inpos+1
          inpos=Instr(a$,"&")
          If inpos<>0 Then
            arg$(2,paramcount)=Mid$(a$,startparam,inpos-startparam)
            a$=Mid$(a$,inpos+1)
            paramcount=paramcount+1
          Else
            arg$(2,paramcount)=Mid$(a$,startparam)
            paramcount=paramcount+1
            processargs=0
          EndIf
        Loop while processargs
      Else
        parsehtmldata$=a$
      EndIf
    Else ' no page requested
      parsehtmldata$="INDEX"
    EndIf
  endif
End Function
  
sub EndSend
  local b$
  b$="AT+CIPSEND="+CHR$(IPDno+48)+","+STR$(len(obuff$)) 'send anything still in the buffer
  IF NOT Command(b$,500,">") THEN
    if LInstr(inbuf(),"link is not valid") then exit sub
  endif
  IF NOT Command(obuff$,500) THEN END
  pause 200 ' LB 170303
  IF NOT Command("AT+CIPCLOSE="+CHR$(IPDno+48),500) THEN
    if LInstr(inbuf(),"UNLINK") then
      obuff$=""
      exit sub
    else
end
    endif
  endif
  obuff$=""
end sub
  
sub SendText(a$)
  local b$
  if firstSend = 1 then
    firstSend = 0
    print a$
  endif
'  print a$;
  if len(a$)+len(obuff$)< 240 then 'add the new string to the output buffer
    obuff$=obuff$+a$
  else 'too big to fit so send the current output buffer
    b$="AT+CIPSEND="+CHR$(IPDno+48)+","+STR$(len(obuff$))
    IF NOT Command(b$,1000,">") THEN ' LB was 500
      if LInstr(inbuf(),"link is not valid") then exit sub
    endif
    IF NOT Command(obuff$,1000) THEN END ' LB was 500
    obuff$=a$
  endif
end sub
'
FUNCTION ReadRequest(timeout%) as integer
'      pin(requestpin) = requestpinVal
'      if requestpinVal = 1 then : requestpinVal = 0 : else : requestpinVal = 1 : endif
  ReadRequest=0
  Longstring Clear inbuf()
  if loc(#9)<>0 then
    do while loc(#9)<>0
      pause 100 ' allow characters to arrive
      longstring append inbuf(),input$(min(255,loc(#9)),#9)
      pause 10 ' allow characters to arrive
    loop
    if (NOT LInstr(inbuf(),"favicon",0)) and (NOT LInstr(inbuf(),"CONNECT FAIL",1)) then
      ReadRequest=1 'junk the favicon requests and disconnects
    endif
    IF LInstr(inbuf(),"IPD,0",1) then IPDno=0
    IF LInstr(inbuf(),"IPD,1",1) then IPDno=1
  endif
end function
'
'
FUNCTION Command(AT$, timeout%, other$) as integer 'send a command and wait for the answer
  local as integer endtime%
  local i%=0,j%
  Local a$
  Command=0
  Longstring Clear inbuf()
  print #9,AT$+crlf;
' LB  TIMER=0
  endtime% = timer+timeout%
  i%=0
  do
    pause 100
' LB    if TIMER>timeout% then
    if TIMER>endtime% then
      Print "Timeout : "+AT$
      EXIT DO
    endif?
    j%=LOC(#9)
    if j%>0 then
      i%=i%+min(255,j%)
      s$=input$(min(255,j%),#9)
      LONGSTRING append inbuf(),s$
      if Llen(inbuf())>4 and other$="" then
        if LInstr(inbuf(),"OK",1) then
          Command=1
          exit DO
        endif
      endif
      if Llen(inbuf())>7 then
        if LInstr(inbuf(),"ERROR",1) then
          Print "ERROR : "+AT$+crlf+"    :"+LGetStr$(inbuf(),1,140)
          exit DO
        endif
      endif
      if Llen(inbuf())>len(other$)+2 then
        if LInstr(inbuf(),other$,1) then
          Command=1
          exit DO
        endif
      endif
    endif
  loop
end function
